package scg.ac.ni.pmf.newgraph.plugin.dpd;

import java.util.Collection;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;

import scg.ac.ni.pmf.newgraph.dpd.DPD;
import scg.ac.ni.pmf.newgraph.graphdata.Graph;
import scg.ac.ni.pmf.newgraph.graphdata.GraphData;
import scg.ac.ni.pmf.newgraph.graphdata.Vertex;
import scg.ac.ni.pmf.newgraph.graphdata.VertexData;
import scg.ac.ni.pmf.newgraph.param.Parametrizable;

/**
 * 
 * @author <a href="mailto: brankovv@beotel.yu">Vladimir Brankov</a>
 */
public class Sum implements DPD, Parametrizable {

	public String getName() {
		return "Sum";
	}

	public String getDescription() {
		return "The sum of two graphs";
	}
	
	public void create(Graph graph) {
		Map ma = new HashMap(), mb = new HashMap();
		
		for(Enumeration i = ga.vertices(); i.hasMoreElements(); ) {
			VertexData u = (VertexData) i.nextElement();
			Collection cu = new Vector();
			for(Enumeration j = gb.vertices(); j.hasMoreElements(); ) {
				VertexData v = (VertexData) j.nextElement();
				if(!mb.containsKey(v))
					mb.put(v, new Vector());
				Collection cv = (Collection) mb.get(v);
				
				Vertex w = graph.createVertex(u.getX() + v.getX(), u.getY() + v.getY());
				cu.add(w);
				cv.add(w);
				for(Enumeration k = u.getNeighbors(); k.hasMoreElements(); ) {
					VertexData u2 = (VertexData) k.nextElement();
					if(ma.containsKey(u2)) {
						for(Iterator l = ((Collection) ma.get(u2)).iterator(); l.hasNext(); ) {
							Vertex w2 = (Vertex) l.next();
							graph.createEdge(w, w2);
						}
					}
				}
				for(Enumeration k = v.getNeighbors(); k.hasMoreElements(); ) {
					VertexData v2 = (VertexData) k.nextElement();
					if(mb.containsKey(v2)) {
						for(Iterator l = ((Collection) mb.get(v2)).iterator(); l.hasNext(); ) {
							Vertex w2 = (Vertex) l.next();
							graph.createEdge(w, w2);
						}
					}
				}
			}
			ma.put(u, cu);
		}
	}

	public String checkParameters() {
		return null;
	}
	
	private GraphData ga;

	public GraphData getGa() {
		return ga;
	}
	
	public void setGa(GraphData ga) {
		this.ga = ga;
	}
	
	private GraphData gb;
	
	public GraphData getGb() {
		return gb;
	}
	
	public void setGb(GraphData gb) {
		this.gb = gb;
	}
	
}
