import java.util.Enumeration;

import scg.ac.ni.pmf.newgraph.action.GraphAction;
import scg.ac.ni.pmf.newgraph.graphdata.Graph;
import scg.ac.ni.pmf.newgraph.graphdata.GraphData;
import scg.ac.ni.pmf.newgraph.graphdata.Vertex;

public class DoubleSelectedAction implements GraphAction {

	public String getName() {
		return "Changers.Double Selected Vertices";
	}

	public String getDescription() {
		return "Doubles the selected vertices.";
	}

	public boolean isEnabled(GraphData graph) {
		return graph.getSelectedVerticesNo() > 0;
	}

	public void action(Graph graph, boolean ctrl, boolean shift) {
		for(Enumeration i = graph.selectedVertices(); i.hasMoreElements(); ) {
			Vertex source = (Vertex) i.nextElement();
			Vertex destination = graph.createVertex(source.getX() + 10, source.getY() + 10);
			for(Enumeration j = source.getNeighbors(); j.hasMoreElements(); ) {
				Vertex v = (Vertex) j.nextElement();
				graph.createEdge(destination, v);
			}
		}
	}

}