import java.util.Enumeration;

import scg.ac.ni.pmf.newgraph.graphdata.Graph;
import scg.ac.ni.pmf.newgraph.graphdata.Vertex;
import scg.ac.ni.pmf.newgraph.graphdata.GraphData;
import scg.ac.ni.pmf.newgraph.graphdata.VertexData;
import scg.ac.ni.pmf.newgraph.invariants.InvariantIntArray;

public class TransposedDegrees implements InvariantIntArray {

        public String getName() {
                return "Transposed degrees";
        }

        public String getDescription() {
                return "Transpose of Ferrer diagram of vertex degrees.";
        }
        
        public int[] calculate(GraphData data) {
                int n = data.getOrder();
                int[] transposed = new int[n];
 
                for (int i=0; i<n; i++)
				    transposed[i] = 0;
					
				for (Enumeration i = data.vertices(); i.hasMoreElements(); ) {
				    VertexData u = (VertexData) i.nextElement();
					int d = data.degree(u.getID());
					for (int j=0; j<d; j++)
				        transposed[j]++;
				}
				
				return transposed;
        }
}
